% LC2 Similarity Measure
% http://campar.in.tum.de/Main/LC2Code
% 
% Chair for Computer Aided Medical Procedures (CAMP)
% Technische Universitaet Muenchen
% Written by: Bernhard Fuerst
% Email: fuerst@in.tum.de
%
% THE WORK IS FOR RESEARCH AND NON-COMMERCIAL PURPOSES ONLY.
% 
% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
% ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
% DISCLAIMED. IN NO EVENT SHALL CAMP BE LIABLE FOR ANY
% DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
% (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
% LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
% ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
% (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
% SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%%
% clean up
close all;
clear all;

%%
% load image
s = 200;
p = phantom('Modified Shepp-Logan', s);
img1 = awgn(p, 10, 'measured');
imagesc(img1);

img2 = zeros(s,s,2);
img2(:,:,1) = p;
img2(:,:,2) = abs(gradient(p));

%%
% Compute similarity
[similarity, measure, weight] = LC2Similarity( img1, img2 )

%%
% Patchwise
patchsize = 9;
similarityPatch = LC2SimilarityPatch( img1, img2, patchsize )
